#!/usr/bin/env python3
# -*- coding: utf-8 -*-
#
# OBJ - Framework to program bots
#
# obj/cmds.py
#
# Copyright 2017,2018 B.H.J Thate
# 
# Permission is hereby granted, free of charge, to any person obtaining a copy 
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights 
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
# 
# The above copyright notice and this permission notice don't have to be included.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
# THE SOFTWARE.
#
# 06-04-2018 As the creator of this file, I disclaim all rights on this file. 
#
# Bart Thate
# Heerhugowaard
# The Netherlands

""" commands module. """

## imports

from obj.base import Object, elapsed
from obj.base import cfg as _cfg
from obj.decorator import oper
from obj.fleet import Fleet
from obj.shell import reboot, reset

import time

## defines

_starttime = time.time()

## vars

fleet = Fleet()

## cmnds

def cfg(event):
    """ show config file dump. """
    if event._parsed.args:
        cfg = Object().load("config/%s" % event._parsed.rest)
    else:
        cfg = _cfg
    event.reply(cfg)

def real_reboot(x):
    """ actual reboot. """
    reset()
    reboot()

@oper
def reboot(event):
    fleet.announce("reboot %s" % time.ctime(time.time()))
    fleet.save("run/fleet")
    real_reboot(event)
    
def uptime(event):
    """ show uptime of the program. """
    event.reply("uptime is %s" % elapsed(time.time() - _starttime))
